-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------

require("socket")
client = socket.connect("192.168.1.214",8998)
IRC = { }

function split(pString, pPattern)
	local Table = {} -- NOTE: use {n = 0} in Lua-5.0
	local fpat = "(.-)" .. pPattern
	local last_end = 1
	local s, e, cap = pString:find(fpat, 1)
	while s do
		if s ~= 1 or cap ~= "" then
			table.insert(Table,cap)
		end
		last_end = e+1
		s, e, cap = pString:find(fpat, last_end)
	end
	if last_end <= #pString then
		cap = pString:sub(last_end)
		table.insert(Table, cap)
	end
	return Table
end

function OnlineMission:StartActivity()

	self.ScreenChange = false;
	self.Flipped = 0;
	current = 1;
	self.ShootDelayTimer = Timer();
	self.UpdateTimer = Timer();
	self.PlayerN = 0;
	self.Plyer = {};
--	self.PlayerCount = 1;
	screenTimer = Timer()
	saytimer = Timer()
	self.Updates = 0;
	lines = 9
	messages = { }
	msg = nil
	verbose = false
	total = ""
	name = "CCLUA"..math.floor(math.random()*1000)
	ip = client:getsockname();
--	connmsg = nil;
--	currentroom = "#CortexIRC"
--	Var1 = 1;
--	Var2 = 2;
--	Var3 = 3;

--	client:send(Var1 .. " " .. Var2 .. " " .. Var3 .. "\n");
	client:send(33 .. "\n");
	client:settimeout(1);
	self.Step = 0;
	Host = false;

		local connmsg, err = client:receive("*l")
		print(connmsg);
		if connmsg ~= nil then
			if string.find(connmsg,"Host ") ~= nil then
				Host = true;
				self.PlayerN = 1;
				print("YOU ARE THE PLAYER 1.");
			elseif string.find(connmsg,"Server Full ") ~= nil then
				print("SORRY THE SERVER IS FULL, NO PLAYING FOR YOU.");
				self.PlayerN = 0;
			elseif string.find(connmsg,"Host ") ~= true and tonumber(connmsg) <= 4 then
				Host = false;
				self.PlayerN = tonumber(connmsg);
--				self.PlayerCount = self.PlayerN;
				print("You are player " .. self.PlayerN .. ".");
			end
		else
			print(err);
		end

    self.Shoot = 0;
    self.Player = CreateAHuman("Robot 1");
    if self.PlayerN > 2 then
    	self.Player.Pos = Vector(1900, 588);
	self.Player.Team = 1;
	self.Brain = CreateActor("Brain Case");
    	self.Brain.Pos = Vector(0, -999);
	self.Player.Team = 1;
	self.Player.HFlipped = true;
    	MovableMan:AddActor(self.Brain);
    else
    	self.Player.Pos = Vector(100, 588);
	self.Player.Team = 0;
	self.Brain = CreateActor("Brain Case");
    	self.Brain.Pos = Vector(0, -999);
	self.Player.Team = 0;
	self.Player.HFlipped = false;
    	MovableMan:AddActor(self.Brain);
    end
    local gun = CreateHDFirearm("Laser Shotgun");
    self.Player:AddInventoryItem(gun);
    MovableMan:AddActor(self.Player);
    --------------------------
    -- Set up players
    for player = 0, self.PlayerCount - 1 do
        -- Check if we already have a brain assigned
        if not self:GetPlayerBrain(player) then
            local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
            -- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
--            if not foundBrain then
--                self.ActivityState = Activity.EDITING;
 --               print("Can't find player brain for tutorial game mode, forcing player to place one manually in edit mode!");
--            else
                -- Set the found brain to be the selected actor at start
                self:SetPlayerBrain(self.Brain, player);
--                self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
                self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
                -- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
                self:SetObservationTarget(self.Brain.Pos, player)
--	end
        end
    end
    
    -- Set up AI modes
    for actor in MovableMan.Actors do
        if actor.Team == self.CPUTeam then
            actor:SetControllerMode(Controller.CIM_AI, -1);
            actor.AIMode = Actor.AIMODE_BRAINHUNT;
        end
    end
	client:settimeout(0.01);
end

-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------

function OnlineMission:PauseActivity(pause)
	if self.PlayerN > 0 then
		client:send(40 .. " " .. self.PlayerN .. "\n");
	end
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------

function OnlineMission:EndActivity()
	if self.PlayerN > 0 then
		client:send(40 .. " " .. self.PlayerN .. "\n");
	end
end

-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------

function OnlineMission:UpdateActivity()
		self.Sent = false;
		if MovableMan:IsActor(self.Player) then
			if not self.Player:IsPlayerControlled() then
				ActivityMan:GetActivity():SwitchToActor(self.Player, Activity.PLAYER_1, 0);
			end
			if self.UpdateTimer:IsPastRealMS(250) and self.PlayerN > 0  then
				if self.Player.HFlipped == true then
					self.Flipped = 1;
				else
					self.Flipped = 0;
				end
				client:send(self.PlayerN .. " " .. math.ceil(self.Player.Pos.X) .. " " .. math.ceil(self.Player.Pos.Y) .. " " .. math.ceil(self.Player.Vel.X) .. " " .. math.ceil(self.Player.Vel.Y) .. " " .. self.Flipped .. " " .. math.ceil(self.Player:GetAimAngle(false)*1000) .. " " .. self.Player.Health .. " " .. self.Shoot .. "\n");
				self.UpdateTimer:Reset();
			end
			if self.Player:GetController():IsState(Controller.WEAPON_FIRE) and self.ShootDelayTimer:IsPastRealMS(1000) and self.PlayerN > 0  then
				self.Shoot = 1;
				client:send(self.PlayerN .. " " .. math.ceil(self.Player.Pos.X) .. " " .. math.ceil(self.Player.Pos.Y) .. " " .. math.ceil(self.Player.Vel.X) .. " " .. math.ceil(self.Player.Vel.Y) .. " " .. self.Flipped .. " " .. math.ceil(self.Player:GetAimAngle(false)*1000) .. " " .. self.Player.Health .. " " .. self.Shoot .. "\n");
				self.ShootDelayTimer:Reset();
			else
				self.Shoot = 0;
			end
			if not self.Player:HasObject("Laser Shotgun") then
    				local gun = CreateHDFirearm("Laser Shotgun");
    				self.Player:AddInventoryItem(gun);
			end
		else
			self.Player = CreateAHuman("Robot 1");
    			if self.PlayerN > 2 then
    				self.Player.Pos = Vector(1900, 588);
				self.Player.Team = 1;
				self.Player.HFlipped = true;
  			else
    				self.Player.Pos = Vector(100, 588);
				self.Player.Team = 0;
				self.Player.HFlipped = false;
    			end
    			local gun = CreateHDFirearm("Laser Shotgun");
    			self.Player:AddInventoryItem(gun);
			MovableMan:AddActor(self.Player);
		end

msg = client:receive("*l");
 if(msg ~= nil) then
	local Data = split(msg, ",");
	if tonumber(Data[1]) ~= self.PlayerN and tonumber(Data[1]) <= 4 then
			if MovableMan:IsActor(self.Plyer[tonumber(Data[1])]) then
				self.Plyer[tonumber(Data[1])].Pos = Vector(tonumber(Data[2]), tonumber(Data[3]));
				self.Plyer[tonumber(Data[1])].Vel = Vector(tonumber(Data[4]), tonumber(Data[5]));
--				print(Data[6]);
				if tonumber(Data[6]) == 1 then
					self.Plyer[tonumber(Data[1])].HFlipped = true;
				elseif tonumber(Data[6]) == 0 then
					self.Plyer[tonumber(Data[1])].HFlipped = false;	
				end
				self.Plyer[tonumber(Data[1])]:SetAimAngle(tonumber(Data[7])/1000);
--				print(tonumber(Data[7])/100);
				self.Plyer[tonumber(Data[1])].Health = tonumber(Data[8]);
				if tonumber(Data[9]) == 1 then
					self.Plyer[tonumber(Data[1])]:GetController():SetState(14,true);
				else
					self.Plyer[tonumber(Data[1])]:GetController():SetState(14,false);
				end
				if not self.Plyer[tonumber(Data[1])]:HasObject("Laser Shotgun1") then
    					local gun = CreateHDFirearm("Laser Shotgun1");
    					self.Plyer[tonumber(Data[1])]:AddInventoryItem(gun);
				end
				else
				self.Plyer[tonumber(Data[1])] = CreateAHuman("Robot 1");
    				self.Plyer[tonumber(Data[1])].Team = 0;
--    				self.Plyer[tonumber(Data[1])].PinStrength = 100000;
				self.Plyer[tonumber(Data[1])].Pos = Vector(tonumber(Data[2]), tonumber(Data[3]));
    				self.Plyer[tonumber(Data[1])].InputMode = 3;
    				self.Plyer[tonumber(Data[1])]:SetControllerMode(Controller.CIM_PLAYER, -1);
    				local gun = CreateHDFirearm("Laser Shotgun1");
    				self.Plyer[tonumber(Data[1])]:AddInventoryItem(gun1);
    				MovableMan:AddActor(self.Plyer[tonumber(Data[1])]);
			end
	end
	if ((tonumber(Data[1]) - 4) <= 4) and MovableMan:IsActor(self.Plyer[(tonumber(Data[1]) - 4)]) then
		self.Plyer[(tonumber(Data[1]) - 4)]:GibThis();
	end
			 
end
--	client:send(Var1 .. " " .. Var2 .. " " .. Var3 .. "\n");


if(screenTimer:IsPastSimMS(10)) then
	FrameMan:ClearScreenText(Activity.PLAYER_1);
	FrameMan:SetScreenText(total,Activity.PLAYER_1,0,-1,false)
	screenTimer:Reset()
end
end