-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------

require("socket")
client = socket.connect("192.168.1.214",8998)
IRC = { }

function split(pString, pPattern)
local Table = {} -- NOTE: use {n = 0} in Lua-5.0
local fpat = "(.-)" .. pPattern
local last_end = 1
local s, e, cap = pString:find(fpat, 1)
while s do
if s ~= 1 or cap ~= "" then
table.insert(Table,cap)
end
last_end = e+1
s, e, cap = pString:find(fpat, last_end)
end
if last_end <= #pString then
cap = pString:sub(last_end)
table.insert(Table, cap)
end
return Table
end

function OnlineMission:StartActivity()

	self.ScreenChange = false;

	current = 1
	self.UpdateTimer = Timer();
	self.PlayerN = 0;
	self.Plyer = {};
	screenTimer = Timer()
	saytimer = Timer()
	self.Updates = 0;
	lines = 9
	messages = { }
	msg = nil
	verbose = false
	total = ""
	name = "CCLUA"..math.floor(math.random()*1000)
	ip = client:getsockname();
--	connmsg = nil;
--	currentroom = "#CortexIRC"
--	Var1 = 1;
--	Var2 = 2;
--	Var3 = 3;

--	client:send(Var1 .. " " .. Var2 .. " " .. Var3 .. "\n");
	client:send(33 .. "\n");
	client:settimeout(0.05);
	self.Step = 0;
	Host = false;
		local connmsg = client:receive("*l")
		print(connmsg);
		if string.find(connmsg,"Host ") ~= nil then
			Host = true;
			self.PlayerN = 1;
			print("YOU ARE THE SERVER HOST.");
		elseif string.find(connmsg,"Host ") ~= true then
			Host = false;
			self.PlayerN = connmsg;
			print("You are player " .. connmsg .. ".");
		end
if Host == true then
    self.Brain = CreateAHuman("Brain Robot");
    self.Brain.Team = 0;
    self.Brain.Pos = Vector(1000, 714)
    MovableMan:AddActor(self.Brain);
end

if Host == false then
    self.Player = CreateAHuman("Robot 1");
    self.Player.Team = 0;
    self.Player.Pos = Vector(self.PlayerN * 62.5, 714)
    MovableMan:AddActor(self.Player);

    self.Plyer[1] = CreateAHuman("Brain Robot");
    self.Plyer[1].Team = 0;
    self.Plyer[1].Pos = Vector(518, 714)
    self.Plyer[1].PinStrength = 100000;
    MovableMan:AddActor(self.Plyer[1]);
end
    --------------------------
    -- Set up players
    
    for player = 0, self.PlayerCount - 1 do
        -- Check if we already have a brain assigned
        if not self:GetPlayerBrain(player) then
            local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
            -- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
            if not foundBrain then
                self.ActivityState = Activity.EDITING;
                print("Can't find player brain for tutorial game mode, forcing player to place one manually in edit mode!");
            else
                -- Set the found brain to be the selected actor at start
                self:SetPlayerBrain(foundBrain, player);
                self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
                self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
                -- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
                self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player)
            end
        end
    end
    
    -- Set up AI modes
    for actor in MovableMan.Actors do
        if actor.Team == self.CPUTeam then
            actor:SetControllerMode(Controller.CIM_AI, -1);
            actor.AIMode = Actor.AIMODE_BRAINHUNT;
        end
    end
	for i = 2,32,1 do
		if self.Player then
			if self.Step ~= self.Player.X or self.Step ~= self.Plyer[1].Pos.X then
    				self.Plyer[i] = CreateAHuman("Robot 1");
    				self.Plyer[i].Team = 0;
    				self.Plyer[i].PinStrength = 100000;
    				self.Plyer[i].Pos = Vector(self.Step, 714)
    				MovableMan:AddActor(self.Plyer[i]);
				self.Step = self.Step + 62.5;
			else
				self.Step = self.Step + 62.5;
			end
		else
			if self.Step ~= self.Brain.X then
    				self.Plyer[i] = CreateAHuman("Robot 1");
    				self.Plyer[i].Team = 0;
    				self.Plyer[i].PinStrength = 100000;
    				self.Plyer[i].Pos = Vector(self.Step, 714)
    				MovableMan:AddActor(self.Plyer[i]);
				self.Step = self.Step + 62.5;
			else
				self.Step = self.Step + 62.5;
			end
		end
	end
end

-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------

function OnlineMission:PauseActivity(pause)

end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------

function OnlineMission:EndActivity()
	client:send("QUIT")
end

-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------

function OnlineMission:UpdateActivity()
		self.Sent = false;
		if Host == true then
			if not self.Brain:IsPlayerControlled() then
				ActivityMan:GetActivity():SwitchToActor(self.Brain, Activity.PLAYER_1, 0);
			end
			if self.UpdateTimer:IsPastRealMS(1000) then
				if self.Sent == false then
					client:send(1 .. " " .. math.ceil(self.Brain.Pos.X) .. " " .. math.ceil(self.Brain.Pos.Y) .. "\n");
					self.Sent = true; 
				end
				self.UpdateTimer:Reset();
			end
		elseif MovableMan:IsActor(self.Player) then
			if not self.Player:IsPlayerControlled() then
				ActivityMan:GetActivity():SwitchToActor(self.Player, Activity.PLAYER_1, 0);
			end
			if self.UpdateTimer:IsPastRealMS(1000) then
				if self.Sent == false then
					client:send(self.PlayerN .. " " .. math.ceil(self.Player.Pos.X) .. " " .. math.ceil(self.Player.Pos.Y) .. "\n");
					self.Sent = true; 
				end
				self.UpdateTimer:Reset();
			end
		end

msg = client:receive("*l");
 if(msg ~= nil) then
	local Data = split(msg, ",");
	if Data[1] ~= self.PlayerN then
		print("Player " .. Data[1] .. " Pos: " .. Data[2] .. ", " .. Data[3]);
--		if 1 <= Data[1] <= 32 then
--			self.Plyer[Data1].Pos = Vector(Data[2], Data[3]);
--		end
	end
end
--	client:send(Var1 .. " " .. Var2 .. " " .. Var3 .. "\n");


if(screenTimer:IsPastSimMS(10)) then
	FrameMan:ClearScreenText(Activity.PLAYER_1);
	FrameMan:SetScreenText(total,Activity.PLAYER_1,0,-1,false)
	screenTimer:Reset()
end

--[[
if(saytimer:IsPastSimMS(500)) then
	IRC:Say(OUTPUT[current])
	current = current + 1
	saytimer:Reset()
end
--]]

local player = 0
local team = self:GetTeamOfPlayer(player); 
        -- Make sure the game is not already ending
if not (self.ActivityState == Activity.OVER or self.ActivityState == Activity.EDITING) then
        -- Check if any player's brain is dead
    if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
        self:SetPlayerBrain(nil, player);
		client:send("PRIVMSG "..currentroom.." :/me has allowed his brain to be destroyed. What a loser.")
        -- Now see if all brains of self player's team are dead, and if so, end the game
        if not MovableMan:GetClosestBrainActor(team) then
			self.WinnerTeam = self:OtherTeam(team);
			ActivityMan:EndActivity();
        end
	end
end
end


--function IRC:Quit()
--	client:send("QUIT\r\n")
--end

-- function IRC:Verbose()
--	verbose = not verbose;
--	print("Verbose mode: "..tostring(verbose))
-- end