import processing.net.*;

Server s;
Client c;
boolean Stopped; // Has the server been stopped yet?
boolean HostJY,TwoJY,ThreeJY,FourJY; // Has the Host Joined Yet?

// Inputs
String input;
int[] data = new int[8]; // 8 For 9 different pieces of info.
String[] pname;

//Minimap Vars
int HostX,HostY,TwoX,TwoY,ThreeX,ThreeY,FourX,FourY;
PImage m;

//Disconnecting Lost Clients
int HostTime,TwoTime,ThreeTime,FourTime,Time;

// Scorekeeping
int Team1Score,Team2Score;

void setup() {
  size(500, 250);
  background(204);
  stroke(0);
  //  frameRate(5); // Slow it down a little
  s = new Server(this, 8998); // Start a simple server on a port
  Stopped = false;
  HostJY = false;
  TwoJY = false;
  ThreeJY = false;
  FourJY = false;
 HostX = 250;
 HostY = 125;
 TwoX = 250;
 TwoY = 125;
 ThreeX = 250;
 ThreeY = 125;
 FourX = 250;
 FourY = 150;
 smooth();
 m = loadImage("Online2.jpg", "jpg");
 image(m,0,0);
}

void draw() {
  Time++;
//  print(Time + "\n");
  if ((mousePressed == true) && (Stopped == false)) {
    s.stop();    // If Mouse clicks, Server Stops Serving.
    print("Stopped.");
    Stopped = true;
  }
  image(m,0,0);
  if (HostJY == true) {
    person(HostX, HostY);
  }
  if (TwoJY == true) {
    person(TwoX, TwoY);
  }
  if (ThreeJY == true) {
    person(ThreeX, ThreeY);
  }
  if (FourJY == true) {
    person(FourX, FourY);
  }
  
  // Receive data from client
  if (Stopped == false) { // If server hasn't stopped yet,
    c = s.available(); // Then c is the next Client

    if (c != null) { // If c exists, go forward.
      input = c.readString(); // Read what c has to say.
      if (input.indexOf("\n") > 0) {
        input = input.substring(0, input.indexOf("\n")); // Read only up to the newline.
        data = int(split(input, ' ')); // Split c's values into an array by the spaces.
        pname = split(input, ' ');
        for (int i=0; i<=data.length; i++) { // Take however many things c said and shove them into the table "data".
        }
          if (data[0] == 33) { // If client throws a 33 (request for Hostship) at me
            if (HostJY == false) { // and the Host hasn't joined yet
              s.write("Host \n"); // I'll send back a "Host" to say he's the Host.
              HostJY = true; //  And I'll tell myself the host has joined.
              HostTime = Time; 
              print("Host Joined \n");
            }
            else if (TwoJY == false) { // otherwise
              s.write(2+"\n");
              TwoJY = true;
              TwoTime = Time; 
              print("Player " + 2 + " Joined. \n");
            }
            else if (ThreeJY == false) {
              s.write(3+"\n");
              ThreeJY = true;
              ThreeTime = Time; 
              print("Player " + 3 + " Joined. \n");
            }
            else if (FourJY == false) {
              s.write(4+"\n");
              FourJY = true;
              FourTime = Time; 
              print("Player " + 4 + " Joined. \n");
            }
            else {
              s.write("Server Full \n");
//              s.disconnect(c);
            }
          }
          if ((data[0] == 50) && (data.length == 2)) {
            if ((data[1] == 1) || (data[1] == 3)) {
              Team1Score++;
              s.write(42 + "," + Team1Score + "\n");
//              print(Team1Score);
            } else if ((data[1] == 2) || (data[1] == 4)) {
              Team2Score++;
              s.write(43 + "," + Team2Score + "\n");
//              print(Team2Score);
            }
          }
          if ((data[0] == 60) && (data.length == 2)) {
            s.write((data[1] + 100) + "\n");
            print("BALLS \n");
          }
          if ((data[0] == 40) && (data.length == 2)) { // If client throws a 33 (request for Hostship) at me
//            print("Someone Left");
            if ((HostJY == true) && (data[1] == 1)) {  //and the Host hasn't joined yet
//              s.write("Host \n"); // I'll send back a "Host" to say he's the Host.
              HostJY = false; //  And I'll tell myself the host has joined.
              print("Host Left. \n");
              s.disconnect(c);
              s.write(5+"\n");
            } 
            else if ((TwoJY == true) && (data[1] == 2)) { // otherwise
//              s.write(2+"\n");
              TwoJY = false;
              print("Player " + 2 + " Left. \n");
              s.disconnect(c);
              s.write(6+"\n");
            } 
            else if ((ThreeJY == true) && (data[1] == 3)) {
//              s.write(3+"\n");
              ThreeJY = false;
              print("Player " + 3 + " Left. \n");
              s.disconnect(c);
              s.write(7+"\n");
            } 
            else if ((FourJY == true) && (data[1] == 4)) {
//              s.write(4+"\n");
              FourJY = false;
              print("Player " + 4 + " Left. \n");
              s.disconnect(c);
              s.write(8+"\n");
              //          print("Player Joined");
            }
          }
          if ((HostJY == true) && (Time - HostTime >= 500)) {  //and the Host hasn't joined yet
//              s.write("Host \n"); // I'll send back a "Host" to say he's the Host.
              HostJY = false; //  And I'll tell myself the host has joined.
              print("Host Timed Out. \n");
//              s.disconnect(c);
              s.write(5+"\n");
            } 
            else if ((TwoJY == true) && (Time - TwoTime >= 500)) { // otherwise
//              s.write(2+"\n");
              TwoJY = false;
              print("Player " + 2 + " Timed Out. \n");
//              s.disconnect(c);
              s.write(6+"\n");
            } 
            else if ((ThreeJY == true) && (Time - ThreeTime >= 500)) {
//              s.write(3+"\n");
              ThreeJY = false;
              print("Player " + 3 + " Timed Out. \n");
//              s.disconnect(c);
              s.write(7+"\n");
            } 
            else if ((FourJY == true) && (Time - FourTime >= 500)) {
//              s.write(4+"\n");
              FourJY = false;
              print("Player " + 4 + " Timed out. \n");
//              s.disconnect(c);
              s.write(8+"\n");
              //          print("Player Joined");
            }

          if ((data[0] > 0) && (data[0] <= 4) && (data.length == 10)) {
              // 0 Is the Player ID, 1 is the X Position, 2 is the Y Position, 3 is the Velocity X, 4 is the Velocity Y, 5 is the HFlipped, 6 is ViewAngle, 7 is the Health, 8 is whether or not he's firing, 9 is their name. 
              s.write(data[0] + "," + data[1] + "," + data[2] + "," + data[3] + "," + data[4] + "," + data[5] + "," + data[6] + "," + data[7] + "," + data[8] + "," + pname[9] + "\n");
            if (data[0] == 1) {  //and the Host hasn't joined yet
              HostX = ceil(data[1]/4);
              HostY = ceil(data[2]/4);
              HostTime = Time; 
            } 
            else if (data[0] == 2) { // otherwise
              TwoX = ceil(data[1]/4);
              TwoY = ceil(data[2]/4);
              TwoTime = Time;
            } 
            else if (data[0] == 3) {
              ThreeX = ceil(data[1]/4);
              ThreeY = ceil(data[2]/4);
              ThreeTime = Time;
            } 
            else if (data[0] == 4) {
              FourX = ceil(data[1]/4);
              FourY = ceil(data[2]/4);
              FourTime = Time;
            }
          }
      }
    }
  }
}

void person(float x, float y) {
  ellipse(x,y,10,10);
}
